unit ChipFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, ActnList, ImgList, ExtDlgs, StdCtrls,
  ExtCtrls;

const
  IMAGE_PATH: String = 'graphic\';
  CHIP_SIZE: Integer = 16;
  ZOOM: Integer = 2;

type
  TChipForm = class(TForm)
    StatusBar: TStatusBar;
    ToolBar: TToolBar;
    ToolButton1: TToolButton;
    ImageList: TImageList;
    ActionList: TActionList;
    OpenPictureDialog: TOpenPictureDialog;
    ChipLoad: TAction;
    ChipLoadButton: TToolButton;
    HorizonScrollBar: TScrollBar;
    VerticalScrollBar: TScrollBar;
    PaintBox: TPaintBox;
    ImageList1: TImageList;
    ToolButton2: TToolButton;
    BanButton: TToolButton;
    GridButton2: TToolButton;
    ToolButton4: TToolButton;
    ToolButton3: TToolButton;
    PinButton: TToolButton;
    ToolButton5: TToolButton;
    procedure ChipLoadExecute(Sender: TObject);
		procedure ScrollBarResize;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
		procedure DrawForm;
    procedure PaintBoxPaint(Sender: TObject);
    procedure PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure HorizonScrollBarChange(Sender: TObject);
    procedure VerticalScrollBarChange(Sender: TObject);
    procedure PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BanButtonClick(Sender: TObject);
    procedure GridButton2Click(Sender: TObject);

		procedure MapChipInit(FileName:String);
    procedure PinButtonClick(Sender: TObject);
    procedure PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

  private
    { Private 錾 }
		OffX,OffY: Integer;
		TmpBGChipImg: TBitmap;
    Grid_View2: Boolean;
    PinFlag: Boolean;

    mouseDownAtField  : Boolean;  // tB[hŃ}EXĂ邩ۂ
  public
    { Public 錾 }
    LoadChipFlag,Ban_flag: Boolean;
		TmpChipImg: TBitmap;
		ChipImgName: String;
    Map_Atty : array of Integer; //}bv̂蔻肪ziƂő傫w肷j
    NowSetParts : Integer; // ݑI𒆂̃p[c
    ChipX_Size,ChipY_Size : Integer;
		sx,sy,ex,ey:Integer;
		SCsrX,SCsrY,ECsrX,ECsrY: Integer;
		SelChip: array of array of Integer;
  end;

var
  ChipForm: TChipForm;

implementation

uses MainFormUnit;

{$R *.dfm}

//==============================================================================
//}bv`bvǂݍ݃ANV
procedure TChipForm.ChipLoadExecute(Sender: TObject);
var
  Attr_Num: Integer;
begin
  with OpenPictureDialog do
  begin
  if Execute = true then
  begin
    if FileExists(FileName) then
		begin
      MapChipInit(FileName);
//---------------------------------------------
      Attr_Num := (ChipX_Size*ChipY_Size);
      SetLength(Map_Atty,Attr_Num);
//---------------------------------------------
    end;
  end;
  end;
end;
//==============================================================================

//==============================================================================
//}bv`bv`揉
procedure TChipForm.MapChipInit(FileName:String);
//var
//  Attr_Num: Integer;
begin
			ChipImgName := FileName;
			TmpChipImg := TBitmap.Create;
			TmpChipImg.LoadFromFile(FileName);

			TmpBGChipImg := TBitmap.Create;
			TmpBGChipImg.Width := PaintBox.Width;
			TmpBGChipImg.Height := PaintBox.Height;

      ChipX_Size := TmpChipImg.Width div CHIP_SIZE;
      ChipY_Size := TmpChipImg.Height div CHIP_SIZE;
			NowSetParts := 0;
//      Attr_Num := (ChipX_Size*ChipY_Size);
//      SetLength(Map_Atty,Attr_Num);
    	LoadChipFlag := True;
      BanButton.Enabled := True;
			GridButton2.Enabled := True;
			ScrollBarResize;
			PaintBox.Visible := True;
			MainForm.MapImgInit;
			PaintBox.Invalidate;
end;
//==============================================================================

//==============================================================================
//tH[ꂽƂ
procedure TChipForm.FormCreate(Sender: TObject);
begin
	PinFlag := True;
  //uǂݍ݁v̏tH_svÖʒu
  OpenPictureDialog.InitialDir := ExtractFilePath(Application.ExeName)+IMAGE_PATH;
	LoadChipFlag := False;
	Ban_flag := False;
	Grid_View2 := False;
	OffX := 0;
	OffY := 0;
	NowSetParts := 0;
	PaintBox.ControlStyle := PaintBox.ControlStyle + [csOpaque];
end;
//==============================================================================

//==============================================================================
//XN[o[̈ʒu𒲐
procedure TChipForm.ScrollBarResize;
var
	ScrollInfo: TScrollInfo;
begin
	VerticalScrollBar.Height :=
	ChipForm.ClientHeight-StatusBar.Height-HorizonScrollBar.Height-ToolBar.Height-5;
	HorizonScrollBar.Width :=
	ChipForm.ClientWidth-VerticalScrollBar.Width-2;
	if LoadChipFlag then
	begin
//------------------------------------------------------------------------------
		if HorizonScrollBar.Width >= (TmpChipImg.Width*ZOOM) then
		begin
			HorizonScrollBar.Max := 0;
    	HorizonScrollBar.Enabled := False;
		end
		else
		begin
      HorizonScrollBar.Max := (TmpChipImg.Width*ZOOM){-HorizonScrollBar.Width};
    	HorizonScrollBar.Enabled := True;
//------------------------------------------------------------------------------
	ScrollInfo.cbSize := Sizeof(TScrollInfo);
	ScrollInfo.fMask := SIF_PAGE;  // nPagêݐݒ肷邱Ƃ
	ScrollInfo.nPage := HorizonScrollBar.Width;  // T̔䗦MaxƂ̔䗦
	SetScrollInfo(ChipForm.HorizonScrollBar.Handle, SB_CTL, ScrollInfo, True);
	if HorizonScrollBar.Focused then // XN[o[ɃtH[JXƂ̂
	begin
		HorizonScrollBar.Enabled := False; // xtH[JXO
		HorizonScrollBar.Enabled := True;
		HorizonScrollBar.SetFocus;     // ēxtH[JX𓖂ĂƓ_ŃTCY
  end;
//------------------------------------------------------------------------------
		end;

		if VerticalScrollBar.Height >= (TmpChipImg.Height*ZOOM) then
		begin
      VerticalScrollBar.Max := 0;
    	VerticalScrollBar.Enabled := False;
		end
		else
		begin
      VerticalScrollBar.Max := (TmpChipImg.Height*ZOOM){-VerticalScrollBar.Height};
    	VerticalScrollBar.Enabled := True;
//------------------------------------------------------------------------------
	ScrollInfo.cbSize := Sizeof(TScrollInfo);
	ScrollInfo.fMask := SIF_PAGE;  // nPagêݐݒ肷邱Ƃ
	ScrollInfo.nPage := VerticalScrollBar.Height;  // T̔䗦MaxƂ̔䗦
	SetScrollInfo(ChipForm.VerticalScrollBar.Handle, SB_CTL, ScrollInfo, True);
	if VerticalScrollBar.Focused then // XN[o[ɃtH[JXƂ̂
	begin
		VerticalScrollBar.Enabled := False; // xtH[JXO
		VerticalScrollBar.Enabled := True;
		VerticalScrollBar.SetFocus;     // ēxtH[JX𓖂ĂƓ_ŃTCY
	end;
  end;
//------------------------------------------------------------------------------
	end;

	if LoadChipFlag then
	begin
		PaintBox.Width := HorizonScrollBar.Width;
		PaintBox.Height := VerticalScrollBar.Height;
		if PaintBox.Width > TmpChipImg.Width*ZOOM then
      PaintBox.Width := TmpChipImg.Width*ZOOM;
		if PaintBox.Height > TmpChipImg.Height*ZOOM then
      PaintBox.Height := TmpChipImg.Height*ZOOM;

		TmpBGChipImg.Width := PaintBox.Width;
		TmpBGChipImg.Height := PaintBox.Height;
	end;

end;
//==============================================================================

//==============================================================================
//tH[TCYꂽƂ
procedure TChipForm.FormResize(Sender: TObject);
begin
	ScrollBarResize;
end;
//==============================================================================

//==============================================================================
//tH[jƂ
procedure TChipForm.FormDestroy(Sender: TObject);
begin
	StatusBar.Panels[0].Text := '';
	StatusBar.Panels[1].Text := '';

	TmpChipImg.Free;
	TmpBGChipImg.Free;
end;
//==============================================================================

//==============================================================================
//tH[ꂽƂ
procedure TChipForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MainForm.ViewChipWin.Checked := False;
end;
//==============================================================================

//==============================================================================
//}bv`bv`
procedure TChipForm.DrawForm;
var
//  xBegin,yBegin: Integer;
	i,j,TmpNow: Integer;

begin
	if LoadChipFlag then
	begin
 	 	TmpBGChipImg.Canvas.CopyRect(
		Rect(-OffX,-OffY,TmpChipImg.Width*ZOOM-OffX,TmpChipImg.Height*ZOOM-OffY),
		TmpChipImg.Canvas,
		Rect(0,0,TmpChipImg.Width,TmpChipImg.Height)
		);
//------------------------------------------------------------------------------
//ʍstOṕ~\
		if Ban_flag then
		begin
  		for i:=0 to ChipY_Size-1 do
  		begin
    	for j:=0 to ChipX_Size-1 do
    	begin
      	TmpNow := i * ChipX_Size + j;
      	ImageList1.Draw(
				TmpBGChipImg.Canvas,
				(j*CHIP_SIZE*ZOOM)-OffX+3,
				(i*CHIP_SIZE*ZOOM)-OffY+3,
				Map_Atty[TmpNow]
				);
    	end;
  		end;
		end
		else
		begin
//------------------------------------------------------------------------------
//IĂ`bvɘgt
//  xBegin := NowSetParts mod ChipX_Size * CHIP_SIZE;
//  yBegin := NowSetParts div ChipX_Size * CHIP_SIZE;

if (SCsrX < ECsrX) then
begin
sx:=SCsrX;
ex:=ECsrX;
end
else
begin
sx:=ECsrX;
ex:=SCsrX;
end;

if (SCsrY < ECsrY) then
begin
sy:=SCsrY;
ey:=ECsrY;
end
else
begin
sy:=ECsrY;
ey:=SCsrY;
end;


TmpBGChipImg.Canvas.Brush.Color:=clBlack;
TmpBGChipImg.Canvas.FrameRect(Rect(
sx*CHIP_SIZE*ZOOM-OffX,
sy*CHIP_SIZE*ZOOM-OffY,
ex*CHIP_SIZE*ZOOM+(CHIP_SIZE*ZOOM)-OffX,
ey*CHIP_SIZE*ZOOM+(CHIP_SIZE*ZOOM)-OffY
));

TmpBGChipImg.Canvas.Brush.Color:=clWhite;
TmpBGChipImg.Canvas.FrameRect(Rect(
sx*CHIP_SIZE*ZOOM-OffX+1,
sy*CHIP_SIZE*ZOOM-OffY+1,
ex*CHIP_SIZE*ZOOM+(CHIP_SIZE*ZOOM)-OffX-1,
ey*CHIP_SIZE*ZOOM+(CHIP_SIZE*ZOOM)-OffY-1
));

TmpBGChipImg.Canvas.Brush.Color:=clBlack;
TmpBGChipImg.Canvas.FrameRect(Rect(
sx*CHIP_SIZE*ZOOM-OffX+2,
sy*CHIP_SIZE*ZOOM-OffY+2,
ex*CHIP_SIZE*ZOOM+(CHIP_SIZE*ZOOM)-OffX-2,
ey*CHIP_SIZE*ZOOM+(CHIP_SIZE*ZOOM)-OffY-2
));


//------------------------------------------------------------------------------
		end;
//------------------------------------------------------------------------------
//ObhC`
  if Grid_View2 then
  begin
	for i:=0 to ChipX_Size do
	begin
    TmpBGChipImg.Canvas.PenPos := Point(i*CHIP_SIZE*ZOOM-OffX,0-OffY);
    TmpBGChipImg.Canvas.LineTo(i*CHIP_SIZE*ZOOM-OffX,ChipY_Size*CHIP_SIZE*ZOOM-OffY);
	end;
	for i:=0 to ChipY_Size do
	begin
    TmpBGChipImg.Canvas.PenPos := Point(0-OffX,i*CHIP_SIZE*ZOOM-OffY);
    TmpBGChipImg.Canvas.LineTo(ChipX_Size*CHIP_SIZE*ZOOM-OffX,i*CHIP_SIZE*ZOOM-OffY);
	end;
	end;
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
		PaintBox.Canvas.Draw(0,0,TmpBGChipImg);
	end;
end;
//==============================================================================

//==============================================================================
//`揈
procedure TChipForm.PaintBoxPaint(Sender: TObject);
begin
  DrawForm;
end;
//==============================================================================

//==============================================================================
//XN[o[PositionςƂ
procedure TChipForm.HorizonScrollBarChange(Sender: TObject);
begin
	if HorizonScrollBar.Position <= ((TmpChipImg.Width*ZOOM)-HorizonScrollBar.Width) then
	begin
		OffX := HorizonScrollBar.Position;
	end
	else
	begin
    HorizonScrollBar.Position := ((TmpChipImg.Width*ZOOM)-HorizonScrollBar.Width);
		OffX := HorizonScrollBar.Position;
	end;
	PaintBox.Invalidate;
end;
//==============================================================================

//==============================================================================
//XN[o[PositionςƂ
procedure TChipForm.VerticalScrollBarChange(Sender: TObject);
begin
	if VerticalScrollBar.Position <= ((TmpChipImg.Height*ZOOM)-VerticalScrollBar.Height) then
	begin
		OffY := VerticalScrollBar.Position;
	end
	else
	begin
		VerticalScrollBar.Position := ((TmpChipImg.Height*ZOOM)-VerticalScrollBar.Height);
		OffY := VerticalScrollBar.Position;
	end;
	PaintBox.Invalidate;
end;
//==============================================================================

//==============================================================================
//PaintBoxŃ}EX{^ꂽƂ
procedure TChipForm.PaintBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  CurX,CurY,NowChip: Integer;
begin

	CurX := (X+OffX) div (CHIP_SIZE*ZOOM);
	CurY := (Y+OffY) div (CHIP_SIZE*ZOOM);



  if Ban_flag then
  begin
    NowChip := CurY * ChipX_Size + CurX;
    if Map_Atty[NowChip] = 0 then
     Map_Atty[NowChip] := 1
    else
      Map_Atty[NowChip] := 0;
  end
  else
  begin

	SCsrX :=CurX;
	SCsrY :=CurY;
  ECsrX := CurX;
  ECsrY := CurY;

		NowSetParts := CurY * ChipX_Size + CurX;
mouseDownAtField := True;
	end;

	PaintBox.Invalidate;
end;
//==============================================================================

//==============================================================================
//PaintBoxŃ}EXƂ
procedure TChipForm.PaintBoxMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
 MoX,MoY: Integer;
begin
	MoX := (X+OffX) div (CHIP_SIZE*ZOOM);
	MoY := (Y+OffY) div (CHIP_SIZE*ZOOM);

if mouseDownAtField then
begin

if MoX > (ChipX_Size-1) then
begin
  ECsrX := ChipX_Size-1;
  MoX := ChipX_Size-1;
end
else
begin
  ECsrX := MoX;
end;

if MoY > (ChipY_Size-1) then
begin
  ECsrY := ChipY_Size-1;
  MoY := ChipY_Size-1;
end
else
begin
  ECsrY := MoY;
end;

StatusBar.Panels[1].Text :=
 '(' +
 IntToStr(sx) +
 '/' +
 IntToStr(sy) +
 ') - (' +
 IntToStr(ex) +
 '/' +
 IntToStr(ey) +
 ')'
;
	PaintBox.Invalidate;
end;

StatusBar.Panels[0].Text :=
 '(' +
 IntToStr(MoX) +
 '/' +
 IntToStr(MoY) +
 '/' +
 IntToStr(ChipX_Size) +
 '/' +
 IntToStr(NowSetParts) +
 ')'
;

end;
//==============================================================================

//==============================================================================
//PaintBoxŃ}EX{^ꂽƂ
procedure TChipForm.PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  CurX,CurY: Integer;
	i,j,BoxX,BoxY: Integer;
begin
  if not(Ban_flag) then
  begin

	CurX := (X+OffX) div (CHIP_SIZE*ZOOM);
	CurY := (Y+OffY) div (CHIP_SIZE*ZOOM);
  ECsrX := CurX;
  ECsrY := CurY;

if CurX > (ChipX_Size-1) then
begin
  ECsrX := ChipX_Size-1;
//  CurX := ChipX_Size-1;
end
else
begin
  ECsrX := CurX;
end;

if CurY > (ChipY_Size-1) then
begin
  ECsrY := ChipY_Size-1;
//  CurY := ChipY_Size-1;
end
else
begin
  ECsrY := CurY;
end;


//------------------------------------------------------------------------------
if (SCsrX < ECsrX) then
begin
sx:=SCsrX;
ex:=ECsrX;
end
else
begin
sx:=ECsrX;
ex:=SCsrX;
end;

if (SCsrY < ECsrY) then
begin
sy:=SCsrY;
ey:=ECsrY;
end
else
begin
sy:=ECsrY;
ey:=SCsrY;
end;

BoxX := ex-sx+1;
BoxY := ey-sy+1;
//------------------------------------------------------------------------------
//͈͑I`bvL
SetLength(SelChip,BoxX,BoxY);

for i := 0 to BoxY-1 do
begin
	for j := 0 to BoxX-1 do
	begin
    SelChip[j,i] := (sy+i) * ChipX_Size + (sx+j);
	end;
end;
//------------------------------------------------------------------------------
end;
StatusBar.Panels[1].Text :=
 '(' +
 IntToStr(sx) +
 '/' +
 IntToStr(sy) +
 ') - (' +
 IntToStr(ex) +
 '/' +
 IntToStr(ey) +
 ')'
;
mouseDownAtField := False;
	PaintBox.Invalidate;
end;
//==============================================================================

//==============================================================================
//ʍsݒ{^
procedure TChipForm.BanButtonClick(Sender: TObject);
begin
  if Ban_flag then
  begin
    Ban_flag := False;
    BanButton.Down := False;
    PaintBox.Cursor := 2;
  end
  else
  begin
    Ban_flag := True;
    BanButton.Down := True;
    PaintBox.Cursor := 0;
  end;

if LoadChipFlag then
	PaintBox.Invalidate;
end;
//==============================================================================

//==============================================================================
//ObhC؂ւ{^
procedure TChipForm.GridButton2Click(Sender: TObject);
begin
  if Grid_View2 then
	begin
    Grid_View2 := False;
    GridButton2.Down := False;
	end
	else
	begin
    Grid_View2 := True;
    GridButton2.Down := True;
	end;
	PaintBox.Invalidate;
end;
//==============================================================================


procedure TChipForm.PinButtonClick(Sender: TObject);
begin
 if PinFlag then
	begin
    PinFlag := False;
		PinButton.Down := False;
		ChipForm.FormStyle := fsNormal;
	end
	else
	begin
    PinFlag := True;
		PinButton.Down := True;
		ChipForm.FormStyle := fsStayOnTop;
	end;
end;

end.
