//==============================================================================
// http://plum.sakura.ne.jp/~s-werke/cppdiary/ RR̃\[XQlɂ
//==============================================================================
unit MainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ToolWin, ComCtrls, StdCtrls, ExtCtrls, ActnList, ImgList;

const
  X_CHIP_MAX: Integer = 20; // ʂɕ\}bv`bv
  Y_CHIP_MAX: Integer = 15;
  CHIP_SIZE: Integer = 16;
//  ZOOM: Integer = 2;
  MAP_PATH: String = 'map\';

type
	BUFSTR = record
  sx:Integer;    //̈E[XW
  sy:Integer;    //̈YW
	end;

type
TMpdHeader = packed Record
	Version : LongWord;	//t@Co[Wʎq
	MapX: Word;					//}bvXTCY
	MapY: Word;					//}bvYTCY
	ChipX: Word;				//`bvXTCY
	ChipY: Word;				//`bvYTCY
end;

type
  TMainForm = class(TForm)
    StatusBar: TStatusBar;
    ToolBar: TToolBar;
    MainMenu: TMainMenu;
    HorizonScrollBar: TScrollBar;
    VerticalScrollBar: TScrollBar;
    PaintBox: TPaintBox;
    ActionList: TActionList;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    ImageList: TImageList;
    CreateNew: TAction;
    File1: TMenuItem;
    ToolButton1: TToolButton;
    New1: TMenuItem;
    N1: TMenuItem;
    ExitApp: TAction;
    Exit1: TMenuItem;
    ToolButton2: TToolButton;
    ViewChipWin: TAction;
    N2: TMenuItem;
    ViewChipWin1: TMenuItem;
    ToolButton3: TToolButton;
    FileSaveButton: TToolButton;
    GridButton: TToolButton;
    PenButton: TToolButton;
    PaintButton: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    FileSave: TAction;
    FileOpen: TAction;
    Open1: TMenuItem;
    Save1: TMenuItem;
    InZoom: TAction;
    OutZoom: TAction;
    ToolButton4: TToolButton;
    ZoomInButton: TToolButton;
    ZoomOutButton: TToolButton;
    ToolButton7: TToolButton;
    Timer1: TTimer;
		Procedure ScrollBarResize;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ExitAppExecute(Sender: TObject);
    procedure CreateNewExecute(Sender: TObject);
    procedure ViewChipWinExecute(Sender: TObject);
		procedure MapImgInit;
		procedure DrawMap;
    procedure PaintBoxPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure HorizonScrollBarChange(Sender: TObject);
    procedure VerticalScrollBarChange(Sender: TObject);
    procedure PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GridButtonClick(Sender: TObject);
    procedure PenButtonClick(Sender: TObject);
    procedure PaintButtonClick(Sender: TObject);
		procedure SubPaint(ix,jy,Parts:Integer);
		procedure scan_line(lx,rx,y,col:Integer);
		procedure dopaint(x, y, paint_color:Integer);
		function SetFileName: Boolean;
    procedure FileSaveExecute(Sender: TObject);
    procedure FileOpenExecute(Sender: TObject);
    procedure InZoomExecute(Sender: TObject);
    procedure OutZoomExecute(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private 錾 }
    Map_Data : array of array of Integer; //}bṽf[^ziƂő傫w肷j
		MapMoto1 : TBitmap;
		MapX,MapY : Integer;	//}bv̏cTCY(`bvP)
    VpX,VpY: Integer;
    mouseDownAtField  : Boolean;  // tB[hŃ}EXĂ邩ۂ
		picked_up  : Boolean;
    xpos_d,Ypos_d: Integer;
    Grid_View: Boolean;

		Buffer: array of BUFSTR;
		Start_Idx,End_Idx: Integer;
    MAXSIZE,MINX,MINY,MAXX,MAXY: Integer;
		currentFileName : String;

		GmsX,GmsY: Integer;
		CurOnBox:Boolean;
 		FMouseControl: TControl;

  public
    { Public 錾 }
//    Map_Atty : array of Integer; //}bv̂蔻肪ziƂő傫w肷j
  	ZOOM: Integer;
  end;

var
  MainForm: TMainForm;

implementation

uses SizeEditUnit, ChipFormUnit;

{$R *.dfm}

//==============================================================================
//tH[ꂽƂ
procedure TMainForm.FormCreate(Sender: TObject);
begin
  ZOOM := 2;
//J[\̓ǂݍ
  Screen.Cursors[1] := LoadCursor(HInstance, 'CurPen');
  Screen.Cursors[2] := LoadCursor(HInstance, 'CurDrop');
  Screen.Cursors[3] := LoadCursor(HInstance, 'CurPaint');
	PaintBox.ControlStyle := PaintBox.ControlStyle + [csOpaque];
	VpX:= 0;
	VpY:= 0;
	MapX:= 0;
	MapY:= 0;
	Grid_View := False;
	mouseDownAtField := False;
	picked_up := False;
  //uǂݍ݁v̏tH_svÖʒu
  OpenDialog.InitialDir := ExtractFilePath(Application.ExeName)+MAP_PATH;
  //uǂݍ݁v̏tH_svÖʒu
  SaveDialog.InitialDir := ExtractFilePath(Application.ExeName)+MAP_PATH;
end;
//==============================================================================

//==============================================================================
//XN[o[̈ʒu𒲐
procedure TMainForm.ScrollBarResize;
var
	ScrollInfo: TScrollInfo;
begin
	VerticalScrollBar.Height :=
	MainForm.ClientHeight-StatusBar.Height-HorizonScrollBar.Height-ToolBar.Height-5;
	HorizonScrollBar.Width :=
	MainForm.ClientWidth-VerticalScrollBar.Width-3;

if ChipForm.LoadChipFlag then
begin
//------------------------------------------------------------------------------
if HorizonScrollBar.Width >= (MapX*CHIP_SIZE*ZOOM) then
begin
	HorizonScrollBar.Max := 0;
	HorizonScrollBar.Enabled := False;
end
else
begin
	HorizonScrollBar.Max := (MapX*CHIP_SIZE*ZOOM);
	HorizonScrollBar.Enabled := True;
//------------------------------------------------------------------------------
	ScrollInfo.cbSize := Sizeof(TScrollInfo);
	ScrollInfo.fMask := SIF_PAGE;  // nPagêݐݒ肷邱Ƃ
	ScrollInfo.nPage := HorizonScrollBar.Width;  // T̔䗦MaxƂ̔䗦
	SetScrollInfo(MainForm.HorizonScrollBar.Handle, SB_CTL, ScrollInfo, True);
	if HorizonScrollBar.Focused then // XN[o[ɃtH[JXƂ̂
	begin
		HorizonScrollBar.Enabled := False; // xtH[JXO
		HorizonScrollBar.Enabled := True;
		HorizonScrollBar.SetFocus;     // ēxtH[JX𓖂ĂƓ_ŃTCY
  end; 
//------------------------------------------------------------------------------
end;

if VerticalScrollBar.Height >= (MapY*CHIP_SIZE*ZOOM) then
begin
	VerticalScrollBar.Max := 0;
	VerticalScrollBar.Enabled := False;
end
else
begin
	VerticalScrollBar.Max := (MapY*CHIP_SIZE*ZOOM);
	VerticalScrollBar.Enabled := True;
//------------------------------------------------------------------------------
 	ScrollInfo.cbSize := Sizeof(TScrollInfo);
	ScrollInfo.fMask := SIF_PAGE;  // nPagêݐݒ肷邱Ƃ
	ScrollInfo.nPage := VerticalScrollBar.Height;  // T̔䗦MaxƂ̔䗦
	SetScrollInfo(MainForm.VerticalScrollBar.Handle, SB_CTL, ScrollInfo, True);
	if VerticalScrollBar.Focused then // XN[o[ɃtH[JXƂ̂
	begin
		VerticalScrollBar.Enabled := False; // xtH[JXO
		VerticalScrollBar.Enabled := True;
		VerticalScrollBar.SetFocus;     // ēxtH[JX𓖂ĂƓ_ŃTCY
	end;
//------------------------------------------------------------------------------
end;
//------------------------------------------------------------------------------
	PaintBox.Width := HorizonScrollBar.Width;
	PaintBox.Height := VerticalScrollBar.Height;

	if PaintBox.Width > MapX*CHIP_SIZE*ZOOM then
    PaintBox.Width := MapX*CHIP_SIZE*ZOOM;
	if PaintBox.Height > MapY*CHIP_SIZE*ZOOM then
    PaintBox.Height := MapY*CHIP_SIZE*ZOOM;

	MapMoto1.Width := PaintBox.Width;
	MapMoto1.Height := PaintBox.Height;
//------------------------------------------------------------------------------
HorizonScrollBar.Position := 0;
VerticalScrollBar.Position := 0;
end;

end;
//==============================================================================

//==============================================================================
//tH[TCYꂽƂ
procedure TMainForm.FormResize(Sender: TObject);
begin
	ScrollBarResize;
end;
//==============================================================================

//==============================================================================
//IANV
procedure TMainForm.ExitAppExecute(Sender: TObject);
begin
  Close;
end;
//==============================================================================

//==============================================================================
//}bvVK쐬ANV
procedure TMainForm.CreateNewExecute(Sender: TObject);
var
  x,y : Integer;
begin
  if SizeEditForm.ShowModal = mrOK then
  begin
		x := StrToIntDef(SIzeEditForm.EditX.Text, X_CHIP_MAX);
		y := StrToIntDef(SizeEditForm.EditY.Text, Y_CHIP_MAX);

		if x <X_CHIP_MAX then
			x := X_CHIP_MAX;
		if y <Y_CHIP_MAX then
			y := Y_CHIP_MAX;
		SetLength(Map_Data,x,y);

		MapX := x;
		MapY := y;

		ChipForm.ChipLoadButton.Enabled := True;
		ScrollBarResize;
	end;
end;
//==============================================================================

//==============================================================================
//`bvEBhE\؂ւANV
procedure TMainForm.ViewChipWinExecute(Sender: TObject);
begin
  if ChipForm.Visible then
	begin
		ChipForm.Visible := False;
    ViewChipWin1.Checked := False;
	end
	else
	begin
		ChipForm.Visible := True;
    ViewChipWin1.Checked := True;
	end;
end;
//==============================================================================

//==============================================================================
//}bv`揉
procedure TMainForm.MapImgInit;
begin
	GridButton.Enabled := True;
	PenButton.Enabled := True;
	PaintButton.Enabled := True;
	FileSaveButton.Enabled := True;
	PaintBox.Width := HorizonScrollBar.Width;
	PaintBox.Height := VerticalScrollBar.Height;

	MapMoto1 := TBitmap.Create;
	MapMoto1.Width := HorizonScrollBar.Width;
	MapMoto1.Height := VerticalScrollBar.Height;
	ScrollBarResize;
	PaintBox.Visible := True;
  PaintBox.Invalidate;

ZoomOutButton.Enabled := True;
ZoomInButton.Enabled := True;
end;
//==============================================================================

//==============================================================================
//}bv`
procedure TMainForm.DrawMap;
var
  i,j: Integer;
  ChipData: Integer;  //e`bṽf[^
  CpX,CpY: Integer;		//`bvPʂ̓]_
  OfX,OfY: Integer;		//hbgPʂ̓]_
  VmapX,VmapY: Integer;
	SCX,SCY: Integer; //I`bv̈ʒu

	CmCX,CmCY: Integer;
	BoxX,BoxY:Integer;
begin

if ChipForm.LoadChipFlag then
begin
	VmapX:= (PaintBox.Width div (CHIP_SIZE*ZOOM))+1;
	VmapY:= (PaintBox.Height div (CHIP_SIZE*ZOOM))+1;
//------------------------------------------------------------------------------
	CpX := (VpX div (CHIP_SIZE*ZOOM));	//`bvP
	OfX := (VpX mod (CHIP_SIZE*ZOOM)); //hbgP

	CpY := (VpY div (CHIP_SIZE*ZOOM));
	OfY := (VpY mod (CHIP_SIZE*ZOOM));
//------------------------------------------------------------------------------
//[vŔz񂩂oāAobNobt@ɓ]
  for i := 0 to VmapY do
  begin
    for j := 0 to VmapX do
    begin

if ((j+CpX) <= (MapX-1)) and ((i+CpY) <= (MapY-1)) then
begin
      ChipData := Map_Data[j+CpX,i+CpY];
      SCY := ChipData div ChipForm.ChipX_Size;
			SCX := ChipData mod ChipForm.ChipX_Size;
			MapMoto1.Canvas.CopyRect(
			Rect(
			(j*CHIP_SIZE*ZOOM)-OfX,
			(i*CHIP_SIZE*ZOOM)-OfY,
			(j*CHIP_SIZE*ZOOM)-OfX+(CHIP_SIZE*ZOOM),
			(i*CHIP_SIZE*ZOOM)-OfY+(CHIP_SIZE*ZOOM)
			),
			ChipForm.TmpChipImg.Canvas,
			Rect(SCX*CHIP_SIZE,SCY*CHIP_SIZE,(SCX*CHIP_SIZE)+CHIP_SIZE,(SCY*CHIP_SIZE)+CHIP_SIZE)
			);
//MapMoto1.Canvas.TextOut((CHIP_SIZE*ZOOM*j)-OfX,(CHIP_SIZE*ZOOM*i)-OfY,IntToStr(j+CpX)+'/'+IntToStr(i+CpY));
end;
    end;
  end;
//------------------------------------------------------------------------------
//ObhC`
  if Grid_View then
  begin
	for i:=0 to VmapX do
	begin
    MapMoto1.Canvas.PenPos := Point(i*CHIP_SIZE*ZOOM-OfX,0-OfY);
    MapMoto1.Canvas.LineTo(i*CHIP_SIZE*ZOOM-OfX,MapY*CHIP_SIZE*ZOOM-OfY);
	end;
	for i:=0 to VmapY do
	begin
    MapMoto1.Canvas.PenPos := Point(0-OfX,i*CHIP_SIZE*ZOOM-OfY);
    MapMoto1.Canvas.LineTo(MapX*CHIP_SIZE*ZOOM-OfX,i*CHIP_SIZE*ZOOM-OfY);
	end;
	end;
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//`bvJ[\
if CurOnBox then
begin
CmCX := (GmsX-CpX)*CHIP_SIZE*ZOOM-OfX;
CmCY := (GmsY-CpY)*CHIP_SIZE*ZOOM-OfY;

BoxX := ChipForm.ex-ChipForm.sx+1;
BoxY := ChipForm.ey-ChipForm.sy+1;

MapMoto1.Canvas.Pen.Color:=clBlack;
MapMoto1.Canvas.Polyline([
Point(CmCX,CmCY),
Point(CmCX,CmCY+(BoxY*CHIP_SIZE*ZOOM)-1),
Point(CmCX+(BoxX*CHIP_SIZE*ZOOM)-1,CmCY+(BoxY*CHIP_SIZE*ZOOM)-1),
Point(CmCX+(BoxX*CHIP_SIZE*ZOOM)-1,CmCY),
Point(CmCX,CmCY)
]);

MapMoto1.Canvas.Pen.Color:=clWhite;
MapMoto1.Canvas.Polyline([
Point(CmCX+1,CmCY+1),
Point(CmCX+1,CmCY+(BoxY*CHIP_SIZE*ZOOM)-2),
Point(CmCX+(BoxX*CHIP_SIZE*ZOOM)-2,CmCY+(BoxY*CHIP_SIZE*ZOOM)-2),
Point(CmCX+(BoxX*CHIP_SIZE*ZOOM)-2,CmCY+1),
Point(CmCX+1,CmCY+1)
]);

MapMoto1.Canvas.Pen.Color:=clBlack;
MapMoto1.Canvas.Polyline([
Point(CmCX+2,CmCY+2),
Point(CmCX+2,CmCY+(BoxY*CHIP_SIZE*ZOOM)-3),
Point(CmCX+(BoxX*CHIP_SIZE*ZOOM)-3,CmCY+(BoxY*CHIP_SIZE*ZOOM)-3),
Point(CmCX+(BoxX*CHIP_SIZE*ZOOM)-3,CmCY+2),
Point(CmCX+2,CmCY+2)
]);

end;
//------------------------------------------------------------------------------

	PaintBox.Canvas.Draw(0,0,MapMoto1);
end;

end;
//==============================================================================

//==============================================================================
//`揈
procedure TMainForm.PaintBoxPaint(Sender: TObject);
begin
	DrawMap;
end;
//==============================================================================

//==============================================================================
//tH[jƂ
procedure TMainForm.FormDestroy(Sender: TObject);
begin
	StatusBar.Panels[0].Text := '';
	StatusBar.Panels[1].Text := '';
	StatusBar.Panels[2].Text := '';
	MapMoto1.Free;
end;
//==============================================================================

//==============================================================================
//PaintBoxŃ}EX{^ꂽƂ
procedure TMainForm.PaintBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
CurX,CurY,pper: Integer;
BoxX,BoxY: Integer;
i,j:Integer;
begin

if ChipForm.LoadChipFlag then
begin
  mouseDownAtField := True;
  CurX := (VpX+X) div (CHIP_SIZE*ZOOM);
  CurY := (VpY+Y) div (CHIP_SIZE*ZOOM);

  if (Button = mbLeft) then // IĂchipu
	begin

if PenButton.Down then //ŷƂ
begin

BoxX := ChipForm.ex-ChipForm.sx;
BoxY := ChipForm.ey-ChipForm.sy;

for i := 0 to BoxY do
begin
	for j := 0 to BoxX do
	begin
    Map_Data[CurX+j,CurY+i] := ChipForm.SelChip[j,i];
	end;
end;



		PaintBox.Invalidate;
end
else
begin  //yL̂Ƃ
//------------------------------------------------------------------------------
pper := Map_Data[CurX,CurY];

if pper <> ChipForm.NowSetParts then
begin
//Map_Data[CurX,CurY] := ChipForm.NowSetParts;
	dopaint(CurX,CurY,ChipForm.NowSetParts);
//	SubPaint(CurX,CurY,pper);
end;
PaintBox.Invalidate;
//------------------------------------------------------------------------------
end;

  end
  else if Button = mbRight then // X|Cg
  begin
    SetCursor(Screen.Cursors[2]);
		ChipForm.NowSetParts := Map_Data[CurX,CurY];

		ChipForm.sx:=ChipForm.NowSetParts mod ChipForm.ChipX_Size;
		ChipForm.sy:=ChipForm.NowSetParts div ChipForm.ChipX_Size;
		ChipForm.ex:=ChipForm.sx;
		ChipForm.ey:=ChipForm.sy;
		ChipForm.SCsrX:=ChipForm.sx;
		ChipForm.SCsrY:=ChipForm.sy;
		ChipForm.ECsrX:=ChipForm.sx;
		ChipForm.ECsrY:=ChipForm.sy;
		SetLength(ChipForm.SelChip,1,1);
		ChipForm.SelChip[0,0] := Map_Data[CurX,CurY];

		ChipForm.PaintBox.Invalidate;
		picked_up := true;  // MouseMove ł͉EĂ邩Ă邩ׂȂ
	end;

  xpos_d := CurX; // MouseMove œꏊŉx`ʂ̂h
  ypos_d := CurY;


end;
end;
//==============================================================================

//==============================================================================
//PaintBoxŃ}EXƂ
procedure TMainForm.PaintBoxMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
CurX,CurY: Integer;
BoxX,BoxY: Integer;
i,j:Integer;
begin

if ChipForm.LoadChipFlag then
begin
  CurX := (VpX+X) div (CHIP_SIZE*ZOOM);
  CurY := (VpY+Y) div (CHIP_SIZE*ZOOM);

	GmsX := CurX;
	GmsY := CurY;

  if picked_up then
    Exit;

	if
((CurX <> xpos_d) or (CurY <> ypos_d))
 and ((CurX < MapX) and (CurY < MapY))
 and ((CurX >= 0) and (CurY >= 0)) then
	begin
		if (mouseDownAtField) and (PenButton.Down) then
		begin
//------------------------------------------------------------------------------
BoxX := ChipForm.ex-ChipForm.sx;
BoxY := ChipForm.ey-ChipForm.sy;

for i := 0 to BoxY do
begin
	for j := 0 to BoxX do
	begin
    Map_Data[CurX+j,CurY+i] := ChipForm.SelChip[j,i];
	end;
end;
//------------------------------------------------------------------------------

//			Map_Data[CurX,CurY] := ChipForm.NowSetParts;
		end;
		PaintBox.Invalidate;
	end;
  xpos_d := CurX; // MouseMove œꏊŉx`ʂ̂h
  ypos_d := CurY;
	StatusBar.Panels[0].Text := '(' + IntToStr(CurX) + '/' + IntToStr(CurY) + ')';
end;
end;
//==============================================================================

//==============================================================================
//PaintBoxŃ}EX{^ꂽƂ
procedure TMainForm.PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if ChipForm.LoadChipFlag then
begin
  SetCursor(Screen.Cursors[1]);
  mouseDownAtField := False;
  picked_up :=false;
end;
end;
//==============================================================================

//==============================================================================
//XN[o[PositionςƂ
procedure TMainForm.HorizonScrollBarChange(Sender: TObject);
begin
	if HorizonScrollBar.Position <= ((MapX*CHIP_SIZE*ZOOM)-HorizonScrollBar.Width) then
	begin
		VpX := HorizonScrollBar.Position;
	end
	else
	begin
    HorizonScrollBar.Position := ((MapX*CHIP_SIZE*ZOOM)-HorizonScrollBar.Width);
		VpX := HorizonScrollBar.Position;
	end;
	PaintBox.Invalidate;

{	StatusBar.Panels[0].Text :=
IntToStr(HorizonScrollBar.Position)+'/'+IntToStr(VerticalScrollBar.Position);}
end;
//==============================================================================

//==============================================================================
//XN[o[PositionςƂ
procedure TMainForm.VerticalScrollBarChange(Sender: TObject);
begin
	if VerticalScrollBar.Position <= ((MapY*CHIP_SIZE*ZOOM)-VerticalScrollBar.Height) then
	begin
		VpY := VerticalScrollBar.Position;
	end
	else
	begin
		VerticalScrollBar.Position := ((MapY*CHIP_SIZE*ZOOM)-VerticalScrollBar.Height);
		VpY := VerticalScrollBar.Position;
	end;
	PaintBox.Invalidate;

{	StatusBar.Panels[0].Text :=
IntToStr(HorizonScrollBar.Position)+'/'+IntToStr(VerticalScrollBar.Position); }
end;
//==============================================================================

//==============================================================================
//ObhC؂ւ{^
procedure TMainForm.GridButtonClick(Sender: TObject);
begin
  if Grid_View then
	begin
    Grid_View:= False;
    GridButton.Down := False;
	end
	else
	begin
    Grid_View:= True;
    GridButton.Down := True;
	end;
	PaintBox.Invalidate;
end;
//==============================================================================

//==============================================================================
//y{^
procedure TMainForm.PenButtonClick(Sender: TObject);
begin
	if not PenButton.Down then
	begin
    PaintButton.Down := False;
    PenButton.Down := True;
	end;
end;
//==============================================================================

//==============================================================================
//yL{^
procedure TMainForm.PaintButtonClick(Sender: TObject);
begin
	if not PaintButton.Down then
	begin
    PenButton.Down := False;
    PaintButton.Down := True;
	end;
end;
//==============================================================================

//==============================================================================
//hԂis:傫Ȕ͈͂h邱ƂłȂj
procedure TMainForm.SubPaint(ix,jy,Parts:Integer);
begin
//
if jy+1 <= MapY-1 then
begin
	if Map_Data[ix,jy+1] = Parts then
  begin
		Map_Data[ix,jy+1] := ChipForm.NowSetParts;
		SubPaint(ix,jy+1,Parts); //̃}Xֈڂ
	end;
end;

//
if jy-1 >= 0 then
begin
	if Map_Data[ix,jy-1] = Parts then
  begin
		Map_Data[ix,jy-1] := ChipForm.NowSetParts;
		SubPaint(ix,jy-1,Parts); //̃}Xֈڂ
	end;
end;

//E
if ix+1 <= MapX-1 then
begin
	if Map_Data[ix+1,jy] = Parts then
  begin
		Map_Data[ix+1,jy] := ChipForm.NowSetParts;
		SubPaint(ix+1,jy,Parts); //̃}Xֈڂ
	end;
end;

//
if ix-1 >= 0 then
begin
	if Map_Data[ix-1,jy] = Parts then
  begin
		Map_Data[ix-1,jy] := ChipForm.NowSetParts;
		SubPaint(ix-1,jy,Parts); //̃}Xֈڂ
	end;
end;

end;
//==============================================================================

//==============================================================================
//hԂXLC
procedure TMainForm.scan_line(lx,rx,y,col:Integer);
begin
	while (lx <= rx) do
	begin
		//̈F΂
		for lx:=lx to rx-1 do
		begin
			if Map_Data[lx,y] = col then Break;
		end;
		if Map_Data[lx,y] <> col then Break;
		//̈F΂
		for lx:=lx to rx do
		begin
			if Map_Data[lx,y] <> col then Break;
		end;
		Buffer[End_Idx].sx := lx-1;
		Buffer[End_Idx].sy := y;
    Inc(End_Idx);
		if (End_Idx = MAXSIZE) then
			End_Idx := End_Idx;
	end;
end;
//==============================================================================

//==============================================================================
//hԂC
// http://www2.starcat.ne.jp/~fussy/algo/algo3-1.htm RR̂𒼂
procedure TMainForm.dopaint(x,y,paint_color:Integer);
var
	lx,rx,uy,dy,col,i:Integer;
begin
	SetLength(Buffer, MapX*MapY);	//obt@̃TCYݒ
	Start_Idx := 0;
	End_Idx := 1;
  Buffer[Start_Idx].sx := x;
  Buffer[Start_Idx].sy := y;
  col := Map_Data[x,y];
	MAXSIZE := MapY;
	MINX := 0;
	MINY := 0;
	MAXX := MapX-1;
	MAXY := MapY-1;

	repeat
		lx := Buffer[Start_Idx].sx;
		rx := Buffer[Start_Idx].sx;
		uy := Buffer[Start_Idx].sy;
		dy := Buffer[Start_Idx].sy;
    Inc(Start_Idx);
    if (Start_Idx = MAXSIZE) then
      Start_Idx := Start_Idx;

		//ς̃V[hȂ疳
		if ( Map_Data[lx,uy] = paint_color) then
			Continue;

		//E̋ET
		while ( rx < MAXX ) do
		begin
			if ( Map_Data[rx+1,uy] <> col ) then Break;
			rx := rx+1;
		end;

		//̋ET
		while ( lx > MINX ) do
		begin
			if ( Map_Data[lx - 1,uy] <> col ) then Break;
			lx := lx-1;
		end;

		//lx-rx̐`
		for i:=lx to rx do
		begin
			Map_Data[i,uy] := paint_color;
		end;
		//^̃XLC𑖍
		uy := uy-1;
		if ( uy >= MINY ) then
			scan_line(lx,rx,uy,col);

		//^̃XLC𑖍
		dy := dy+1;
		if ( dy <= MAXY ) then
			scan_line(lx,rx,dy,col);

	until (Start_Idx = End_Idx);
end;
//==============================================================================

//==============================================================================
// t@C`FbNA
function TMainForm.SetFileName: Boolean;
var
  ret : Word;//t@C㏑mFptO
begin

  with SaveDialog do begin
    if Execute = true then begin
      if FileExists(FileName) then begin
        ret := MessageDlg('̃t@C͂łɑ݂Ă܂B㏑܂H',
                      mtConfirmation, [mbYes, mbNo, mbCancel], 0);
        if (ret = mrNo) or (ret = mrCancel) then
				begin
          Result := false;
          Exit;
        end;
      end;
      if AnsiPos('.mpd', FileName) = 0 then // '.mpd'  FileName ɂ邩ׂ
        FileName := FileName + '.mpd';
      currentFileName := FileName;
      Result := true
    end
    else
      Result := false;
  end;

 end;
//==============================================================================

//==============================================================================
//t@Cۑ
procedure TMainForm.FileSaveExecute(Sender: TObject);
var
  f: TFileStream;
	i,j,Cfn : Integer;
 	P: PChar;

//  version : LongWord;
	tmpChipFileName: String;
//	smx,smy: Word;
//	cmx,cmy: Word;
	attrda : Byte;
	attrmax: Integer;
	mapdar : Word;

  MpdHead:TMpdHeader;
begin
  MpdHead.version := $3144504D;
	MpdHead.MapX := MapX;
	MpdHead.MapY := MapY;
	MpdHead.ChipX := ChipForm.ChipX_Size;
	MpdHead.ChipY := ChipForm.ChipY_Size;
	attrmax := (MpdHead.ChipX*MpdHead.ChipY)-1;
	tmpChipFileName := ExtractFileName(ChipForm.ChipImgName);
	Cfn := Length(tmpChipFileName);
	P:= PChar(tmpChipFileName);

	if SetFileName = false then Exit;

  f := TFileStream.Create(currentFileName, fmCreate or fmOpenWrite);
	try
  	f.WriteBuffer(MpdHead, sizeof(TMpdHeader));
//  	f.WriteBuffer(version, sizeof(version));
//  	f.WriteBuffer(smx, sizeof(smx));
//  	f.WriteBuffer(smy, sizeof(smy));
//  	f.WriteBuffer(cmx, sizeof(cmx));
//  	f.WriteBuffer(cmy, sizeof(cmy));

		for i:=0 to attrmax do
		begin
			attrda := ChipForm.Map_Atty[i];
			f.WriteBuffer(attrda, sizeof(attrda));
		end;
		for i:=0 to Cfn do
		begin
			f.WriteBuffer(P[i], 1);
		end;

		for i:=0 to MpdHead.MapY-1 do
		begin
			for j:=0 to MpdHead.MapX-1 do
			begin
				mapdar := Map_Data[j,i];
				f.WriteBuffer(mapdar, sizeof(mapdar));
			end;
		end;

	finally
  	f.Free;
	end;
showmessage('');

end;
//==============================================================================

//==============================================================================
//t@CJ
procedure TMainForm.FileOpenExecute(Sender: TObject);
var
	i,j{,Cfn} : Integer;
//P: PChar;

  f: TFileStream;
//  version : LongWord;
//	smx,smy: Word;
//	cmx,cmy: Word;
	attrda : array of Byte;
	attrmax: Integer;
	tmpStr: Byte;
	tmpname: String;
	mapda : array of array of Integer;
  chipfn:String;

  MpdHead:TMpdHeader;
begin

  with OpenDialog do
  begin
    if Execute = true then
		begin
//------------------------------------------------------------------------------

      f:= TFileStream.Create(FileName, fmOpenRead);
      try
				f.ReadBuffer(MpdHead, sizeof(TMpdHeader));
//  			f.ReadBuffer(version, sizeof(version));
    		if MpdHead.version <> $3144504D then begin
					MessageDlg('t@C`Ⴄ߁AJ܂',mtWarning	,[mbOK],0);
        	Exit;
    		end;
//  			f.ReadBuffer(smx, sizeof(smx));
//  			f.ReadBuffer(smy, sizeof(smy));
//  			f.ReadBuffer(cmx, sizeof(cmx));
//  			f.ReadBuffer(cmy, sizeof(cmy));


				SetLength(mapda,MpdHead.MapX,MpdHead.MapY);
				attrmax := (MpdHead.ChipX*MpdHead.ChipY);
				SetLength(attrda,attrmax);
				for i:=0 to attrmax-1 do
				begin
					f.ReadBuffer(attrda[i], sizeof(Byte));
				end;

				for i:=0 to 255 do
				begin
					f.ReadBuffer(tmpStr, sizeof(Byte));
					if tmpStr = 0 then Break;
					tmpname := tmpname + chr(tmpStr);
				end;
				for i:=0 to MpdHead.MapY-1 do
				begin
					for j:=0 to MpdHead.MapX-1 do
			 		begin
						f.ReadBuffer(mapda[j,i], sizeof(Word));
					end;
				end;
//------------------------------------------------------------------------------
				SetLength(Map_Data,MpdHead.MapX,MpdHead.MapY);
        MapX:=MpdHead.MapX;
        MapY:=MpdHead.MapY;

				for i:=0 to MpdHead.MapY-1 do
				begin
					for j:=0 to MpdHead.MapX-1 do
			 		begin
						Map_Data[j,i] := mapda[j,i];
					end;
				end;

        ChipForm.ChipLoadButton.Enabled := True;
				ScrollBarResize;

//------------------------------------------------------------------------------

  				chipfn := ExtractFilePath(Application.ExeName)+'graphic\'+tmpname;

					ChipForm.MapChipInit(chipfn);

					SetLength(ChipForm.Map_Atty,attrmax);

					for j:=0 to attrmax-1 do
			 		begin
						ChipForm.Map_Atty[j] := attrda[j];
					end;
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------

			finally
  			f.Free;
			end;
//------------------------------------------------------------------------------
		end;
  end;

end;
//==============================================================================

//==============================================================================
procedure TMainForm.InZoomExecute(Sender: TObject);
begin
	if ZoomOutButton.Down then
	begin
		ZOOM := 2;
		ScrollBarResize;
		PaintBox.Invalidate;
		ZoomOutButton.Down := False;
		ZoomInButton.Down := True;
	end
	else
	begin
		ZoomInButton.Down := True;
	end;
end;
//==============================================================================

//==============================================================================
procedure TMainForm.OutZoomExecute(Sender: TObject);
begin
	if ZoomInButton.Down then
	begin
		ZOOM := 1;
		ScrollBarResize;
		PaintBox.Invalidate;
		ZoomInButton.Down := False;
		ZoomOutButton.Down := True;
	end
	else
	begin
		ZoomOutButton.Down := True;
	end;
end;
//==============================================================================

//==============================================================================
procedure TMainForm.Timer1Timer(Sender: TObject);
var
//P: TPoint;
//NowP: TPoint;
P1: TPoint;
Control1: TControl;
begin

if ChipForm.LoadChipFlag then
begin

  GetCursorPos(P1);
  Control1 := FindDragTarget(P1, True);

  if FMouseControl <> Control1 then
  begin
		// Rg[}EXł
    if FMouseControl = PaintBox then
		begin
  		CurOnBox := False;
  		SetCursor(Screen.Cursors[0]);
			PaintBox.Cursor := crDefault;
  		//mouseDownAtField := False;
  		picked_up :=false;
		//if ChipForm.LoadChipFlag then
  		PaintBox.Invalidate;
		end;

    FMouseControl := Control1;
    // Rg[Ƀ}EXƂ
    if FMouseControl = PaintBox then
		begin
  		CurOnBox := True;
  		SetCursor(Screen.Cursors[1]);
			PaintBox.Cursor := 1;
		//if ChipForm.LoadChipFlag then
  		PaintBox.Invalidate;
		end;

	end;

end;

end;
//==============================================================================

end.
 